﻿// CodeGear C++Builder
// Copyright (c) 1995, 2017 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'rMapiMail.pas' rev: 33.00 (Windows)

#ifndef RmapimailHPP
#define RmapimailHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.Classes.hpp>
#include <Vcl.Graphics.hpp>
#include <Winapi.Windows.hpp>
#include <System.SysUtils.hpp>
#include <System.StrUtils.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Controls.hpp>
#include <System.Variants.hpp>
#include <Vcl.OleCtrls.hpp>
#include <System.Win.ComObj.hpp>

//-- user supplied -----------------------------------------------------------

//-- forward type declarations -----------------------------------------------
class DELPHICLASS TrMapiEmail;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TRunMailType : unsigned char { rmInternal, rmExternalAppOnly, rmExternalAppPrefered };

enum DECLSPEC_DENUM TRunMailMapiVersion : unsigned char { rmAuto, rmAnsi, rmUnicode };

enum DECLSPEC_DENUM TRunMailMapiOutlook : unsigned char { rmMapiOnly, rmOutlookOnly, rmMapiPreferred, rmOutlookPreferred };

enum DECLSPEC_DENUM TOutlookOption : unsigned char { ooUseRunningApplication, ooShowEmailModal };

typedef Set<TOutlookOption, TOutlookOption::ooUseRunningApplication, TOutlookOption::ooShowEmailModal> TOutlookOptions;

class PASCALIMPLEMENTATION TrMapiEmail : public TComponent
{
	typedef TComponent inherited;
	
private:
	Byte FBatchConfirmCount;
	TStrings* FSendTo;
	TStrings* FCopyTo;
	TStrings* FBlindCopyTo;
	UnicodeString FSubject;
	TStrings* FBody;
	TStrings* FAttachments;
	bool FShowErrorDlg;
	bool FRemoveRecepientsDuplicity;
	TStrings* FMailIniCfg;
	TStrings* FBatchMailList;
	UnicodeString FMailAppDirectory;
	UnicodeString FAddressPrefix;
	bool FSendAutomatically;
	bool FUseOutlook;
	TOutlookOptions FOutlookOptions;
	void __fastcall SetSendTo(TStrings* Value);
	void __fastcall SetCopyTo(TStrings* Value);
	void __fastcall SetBlindCopyTo(TStrings* Value);
	void __fastcall SetBody(TStrings* Value);
	void __fastcall SetAttachments(TStrings* Value);
	
protected:
	bool __fastcall GetNameAddress(const UnicodeString s, UnicodeString &name, UnicodeString &address);
	void __fastcall CleanStrings(TStrings* L, bool CheckFileName = false);
	void __fastcall CleanAll();
	void __fastcall AddMailList(bool UseOutlook);
	bool __fastcall ProcMapiMail();
	bool __fastcall ProcMapiMailW();
	bool __fastcall ProcOutlookOLE();
	bool __fastcall RunExternalMailTool(TStrings* L);
	bool __fastcall ProcBatchMail();
	UnicodeString __fastcall GetMailAppDir();
	int __fastcall GetFirstHTMLAttachmentIndex();
	
public:
	__fastcall virtual TrMapiEmail(TComponent* AOwner);
	__fastcall virtual ~TrMapiEmail();
	bool __fastcall ExternalAppExists();
	void __fastcall ExternalAppLoadSendMail(UnicodeString IniFileName = UnicodeString(), bool DeleteAfterSend = true);
	void __fastcall InitMail();
	bool __fastcall SendSimpleMail();
	bool __fastcall SendMapiMail(TRunMailType RunMailType = (TRunMailType)(0x2), TRunMailMapiVersion RunMailVersion = (TRunMailMapiVersion)(0x0));
	bool __fastcall SendOutlookMail(TRunMailType RunMailType = (TRunMailType)(0x2));
	bool __fastcall SendAutoSelect(TRunMailMapiOutlook MapiOrOutlook = (TRunMailMapiOutlook)(0x3));
	void __fastcall AddToBatchMail(bool UseOutlook = false);
	void __fastcall InitBatchMail();
	bool __fastcall SendBatchMail(TRunMailType RunMailType = (TRunMailType)(0x2));
	__property TStrings* BatchMailList = {read=FBatchMailList};
	
__published:
	__property Byte BatchConfirmCount = {read=FBatchConfirmCount, write=FBatchConfirmCount, default=10};
	__property TStrings* SendTo = {read=FSendTo, write=SetSendTo};
	__property TStrings* CopyTo = {read=FCopyTo, write=SetCopyTo};
	__property TStrings* BlindCopyTo = {read=FBlindCopyTo, write=SetBlindCopyTo};
	__property UnicodeString Subject = {read=FSubject, write=FSubject};
	__property TStrings* Body = {read=FBody, write=SetBody};
	__property TStrings* Attachments = {read=FAttachments, write=SetAttachments};
	__property bool ShowErrorDlg = {read=FShowErrorDlg, write=FShowErrorDlg, default=0};
	__property UnicodeString MailAppDirectory = {read=FMailAppDirectory, write=FMailAppDirectory};
	__property bool RemoveRecepientsDuplicity = {read=FRemoveRecepientsDuplicity, write=FRemoveRecepientsDuplicity, default=1};
	__property bool SendAutomatically = {read=FSendAutomatically, write=FSendAutomatically, default=0};
	__property TOutlookOptions OutlookOptions = {read=FOutlookOptions, write=FOutlookOptions, default=1};
};


//-- var, const, procedure ---------------------------------------------------
#define smRunFile L"SendMail.exe"
#define smIniFile L"SendMail.ini"
#define smSendTo L"SendTo"
#define smCopyTo L"CopyTo"
#define smBlindCopyTo L"BlindCopyTo"
#define smSubject L"Subject"
#define smBody L"Body"
#define smAttachedFile L"AttachedFile"
#define smShowDialog L"ShowDialog"
#define smUseOutlook L"UseOutlook"
#define smNextMail L"NextMail"
#define smConfirmCounter L"ConfirmCounter"
#define smUseNameOnlyPrefix L"NAME:"
extern DELPHI_PACKAGE void __fastcall Register();
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RmapimailHPP
